// html.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string>
#include <libcgi++.h>

#include "dbd.h"

#include "html.h"


void error(char *s)
{
	printf("\n");		// End of http header

	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(stdout);
	printf("<html><head><title>Error</title>");
	printf("<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	printf("</head>\n");
	printf("<body> <h1>Error</h1> This is the text of the error message: '%s' </body></html>\n",s);
	fflush(stdout);
	exit(-1);
}

void header_top(char *s,long useronline)
{
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(stdout);
	printf("<html><head><base target=rf><title>%s</title>",s);
	printf("<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	printf("</head>\n");
	printf("<body>"); // background=/image/dbdinnehall.gif BGPROPERTIES=fixed>\n");
	if (*s)
		printf("<h3>%s</h3>",s);
	if (*errstr)
		printf("<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ff8080\"><font size=\"+1\">%s</font></td></tr></table>\n",errstr);
	if (*warningstr)
		printf("<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ffff80\"><font size=\"+1\">%s</font></td></tr></table>\n",warningstr);
}


// normal page header when user is logged in

void header0(char *s,long useronline,Cookies *cs)
{
	char slask[100];
	
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(stdout);
	printf("<html><head><base target=rf><title>%s</title>",s);
	printf("<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	printf("</head>\n");
	printf("<body>"); // background=/image/dbdinnehall.gif BGPROPERTIES=fixed>\n");
	// new menu
	std::string td_class = "x";
	std::string a_class = "x";
/*
			set_cookie(cs,"ui",0L);
			set_cookie(cs,"dba","0");
			set_cookie(cs,"ed","0");
*/
	bool design = false;
	bool ui = (cs -> getvalue("ui",slask,100) && *slask && atoi(slask)) ? true : false;
	bool dba = (cs -> getvalue("dba",slask,100) && *slask && atoi(slask)) ? true : false;
	bool ed = (cs -> getvalue("ed",slask,100) && *slask && atoi(slask)) ? true : false;
	cs -> getvalue("show_page",slask,100);
	int show_page = atoi(slask);
	bool sql = show_page == 20;
	bool diagram = show_page == 38;
	bool ls = show_page == 22;
	if (sql || diagram || ls)
	{
		ui = dba = ed = false;
	}
	if (!ui && !dba && !ed && !sql && !diagram && !ls)
	{
		design = true;
	}
	printf("<table cellpadding=0 cellspacing=0><tr>");
	printf("<td class=mbeg>&nbsp;</td>");

	td_class = design ? "y" : "x";
	printf("<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?design=0\">design</a></td>",td_class.c_str(),a_class.c_str());
	td_class = ed ? "y" : "x";
	printf("<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?ed=0\">edit&nbsp;data</a></td>",td_class.c_str(),a_class.c_str());
	td_class = diagram ? "y" : "x";
	printf("<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?diagram=0\">diagram</a></td>",td_class.c_str(),a_class.c_str());
	td_class = sql ? "y" : "x";
	printf("<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?sql=1\">generate&nbsp;sql</a></td>",td_class.c_str(),a_class.c_str());
	td_class = ui ? "y" : "x";
	printf("<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?ui=0\">user&nbsp;info</a></td>",td_class.c_str(),a_class.c_str());
	td_class = dba ? "y" : "x";
	printf("<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?dba=0\">db&nbsp;access</a></td>",td_class.c_str(),a_class.c_str());
	td_class = ls ? "y" : "x";
	printf("<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?ls=0\">live&nbsp;sync</a></td>",td_class.c_str(),a_class.c_str());
	td_class = "x";
	printf("<td class=%s><a target=_top class=%s href=\"/cgi-bin/dbd/dbd?logout=0\">logout</a></td>",td_class.c_str(),a_class.c_str());

	printf("</tr></table>");
	printf("<div style=\"width: 100%; height: 8px; background: #c0c0c0\">");
	printf("</div>");
	printf("<div style=\"width: 100%; height: 4px; background: #ffffff\">");
	printf("</div>");
	// end of new menu
	printf("<div style=\"padding: 5px;\">");

	if (*s)
		printf("<h3>%s</h3>",s);
	if (*errstr)
		printf("<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ff8080\"><font size=\"+1\">%s</font></td></tr></table>\n",errstr);
	if (*warningstr)
		printf("<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ffff80\"><font size=\"+1\">%s</font></td></tr></table>\n",warningstr);
}


// top header (useronline = 1), login header, new user header

void header(char *s,long useronline)
{
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(stdout);
	printf("<html><head><base target=rf><title>%s</title>",s);
//	if (*s)
//		printf("<title>%s: %s</title>",TITLE,s);
//	else
//		printf("<title>%s</title>",TITLE);
	printf("<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	printf("</head>\n");
	printf("<body>"); // bgcolor=\"#66ddfe\">");
	printf("<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td valign=middle>");
	if (*s)
		printf("<h1>%s: %s</h1>",TITLE,s);
	else
		printf("<h1>%s</h1>",TITLE);
//		printf("<img src=/image/dbdlogo.gif>");
	printf("</td>");
	printf("<td valign=top align=right>");
//	printf("<form action=/cgi-bin/dbd/dbd method=post>");
//	printf("<input type=submit name=logout value=\" Logout \">");
//	printf("</form>");

// useronline = 1 design
//  2 db access
//  3 user info
//  4 -
//  5 edit data
//  6 generate sql
//

	if (useronline)
	{
	useronline = 999;
		printf("[\n");
		if (useronline == 1)
			printf("design\n");
		else
			printf("<a href=\"/cgi-bin/dbd/dbd?design=0\">design</a>\n");
		printf("|\n");
		printf("<a href=\"/cgi-bin/dbd/dbd?ed=0\">edit&nbsp;data</a>\n");
		printf("|\n");
		printf("<a href=\"/cgi-bin/dbd/dbd?sql=1\">generate&nbsp;sql</a>\n");
		printf("|\n");
		printf("<a href=\"/cgi-bin/dbd/dbd?diagram=0\">diagram</a>\n");
		printf("|\n");
		if (useronline == 2)
			printf("db&nbsp;access\n");
		else
			printf("<a href=\"/cgi-bin/dbd/dbd?dba=0\">db&nbsp;access</a>\n");
		printf("|\n");
		if (useronline == 3)
			printf("user&nbsp;info\n");
		else
			printf("<a href=\"/cgi-bin/dbd/dbd?ui=0\">user&nbsp;info</a>\n");
		printf("|\n");
		printf("<a target=_top href=\"/cgi-bin/dbd/dbd?logout=0\">logout</a>\n");
		printf("]");
		printf("<br>");
		printf("[ <a href=\"/cgi-bin/dbd/dbd?ls=0\">live&nbsp;sync</a> ]");
	}
	printf("</td></tr></table>");
	if (*errstr)
		printf("<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ff8080\"><font size=\"+1\">%s</font></td></tr></table>",errstr);
	if (*warningstr)
		printf("<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ffff80\"><font size=\"+1\">%s</font></td></tr></table>",warningstr);
}

void nullheader(char *s,long useronline)
{
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(stdout);
	printf("<html><head><title>%s</title>",s);
//	if (*s)
//		printf("<title>%s: %s</title>",TITLE,s);
//	else
//		printf("<title>%s</title>",TITLE);
	printf("<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	printf("</head>\n");
	printf("<body style=\"padding: 10px;\">"); // bgcolor=\"#66ddfe\">");
	printf("<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td valign=middle>");
	if (*s)
		printf("<h1>%s: %s</h1>",TITLE,s);
	else
		printf("<h1>%s</h1>",TITLE);
//		printf("<img src=/image/dbdlogo.gif>");
	printf("</td>");
	printf("<td valign=top align=right>");
//	printf("<form action=/cgi-bin/dbd/dbd method=post>");
//	printf("<input type=submit name=logout value=\" Logout \">");
//	printf("</form>");

// useronline = 1 design
//  2 db access
//  3 user info
//  4 -
//  5 edit data
//  6 generate sql
//

	if (useronline)
	{
	useronline = 999;
		printf("[\n");
		if (useronline == 1)
			printf("design\n");
		else
			printf("<a href=\"/cgi-bin/dbd/dbd?design=0\">design</a>\n");
		printf("|\n");
		printf("<a href=\"/cgi-bin/dbd/dbd?ed=0\">edit&nbsp;data</a>\n");
		printf("|\n");
		printf("<a href=\"/cgi-bin/dbd/dbd?sql=1\">generate&nbsp;sql</a>\n");
		printf("|\n");
		printf("<a href=\"/cgi-bin/dbd/dbd?diagram=0\">diagram</a>\n");
		printf("|\n");
		if (useronline == 2)
			printf("db&nbsp;access\n");
		else
			printf("<a href=\"/cgi-bin/dbd/dbd?dba=0\">db&nbsp;access</a>\n");
		printf("|\n");
		if (useronline == 3)
			printf("user&nbsp;info\n");
		else
			printf("<a href=\"/cgi-bin/dbd/dbd?ui=0\">user&nbsp;info</a>\n");
		printf("|\n");
		printf("<a target=_top href=\"/cgi-bin/dbd/dbd?logout=0\">logout</a>\n");
		printf("]");
		printf("<br>");
		printf("[ <a href=\"/cgi-bin/dbd/dbd?ls=0\">live&nbsp;sync</a> ]");
	}
	printf("</td></tr></table>");
	if (*errstr)
		printf("<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ff8080\"><font size=\"+1\">%s</font></td></tr></table>",errstr);
	if (*warningstr)
		printf("<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ffff80\"><font size=\"+1\">%s</font></td></tr></table>",warningstr);
}

void footer(void)
{
	printf("<br><br>[\n");
	printf("<a target=_top href=\"/cgi-bin/dbd/dbd?repair=0\">repair frames</a>\n]<br>");
	printf("<br>");
	printf("</div>"); // padding 5px
	printf("</body></html>\n");
}

// images

void iplus(void)
{
	printf("<IMG SRC='/image/iplus-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iplusend(void)
{
	printf("<IMG SRC='/image/iplus-end-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iexpanded(void)
{
	printf("<IMG SRC='/image/iminus-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void inotexpanded(void)
{
	printf("<IMG SRC='/image/iplus-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iclosed(void)
{
	printf("<IMG SRC='/image/ifolder-closed-0.gif' WIDTH=16 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iminus(void)
{
	printf("<IMG SRC='/image/iminus-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iminusend(void)
{
	printf("<IMG SRC='/image/iminus-end-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iopen(void)
{
	printf("<IMG SRC='/image/ifolder-open-0.gif' WIDTH=16 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ivertline(void)
{
	printf("<IMG SRC='/image/ivert-line-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ibranchcont(void)
{
	printf("<IMG SRC='/image/ibranch-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP border=0>");
}

void ibranchend(void)
{
	printf("<IMG SRC='/image/ibranch-end-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP border=0>");
}

void iglobe(void)
{
	printf("<IMG SRC='/image/globe.gif' WIDTH=16 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iglobe0(void)
{
	printf("<IMG SRC='/image/iglobe-0.gif' WIDTH=16 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ithumbsup(void)
{
	printf("<IMG SRC='/image/thumbsup2.gif' HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ithumbsdown(void)
{
	printf("<IMG SRC='/image/thumbsdn2.gif' HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ipascal(void)
{
	printf("<IMG SRC='/image/pascal.gif' HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iempty(void)
{
	printf("<IMG SRC='/image/iempty.gif' HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}
